<template>
  <v-container class="pa-0">
    <div class="mb-4 d-flex align-center">
      <span class="font-weight-bold">Animaux</span>
      <v-badge :content="animalList.length" v-if="animalList && animalList.length > 0" inline
        data-cy="AnimalListCountBadge" class="inverted standalone">
      </v-badge>
      <v-badge :content="nbrAnimalErrors + ' Erreurs'" v-if="nbrAnimalErrors && nbrAnimalErrors > 0" inline
        data-cy="AnimalListErrorsBadge" class="standalone" color="error">
      </v-badge>
      <v-badge :content="nbrAnimalDuplicates + ' Doublons'" v-if="nbrAnimalDuplicates && nbrAnimalDuplicates > 0" inline
        data-cy="AnimalListWarningsBadge" class="standalone" color="warning">
      </v-badge>
    </div>

    <div class="mb-8 d-flex justify-space-between align-center">
      <div class="flex w-100 d-flex align-center">
        <v-text-field placeholder="Recherche" data-cy="AnimalListSearchInput" clearable density="compact" plain rounded variant="outlined"
          v-model="query" class="mr-6" max-width="400" color="primary" hide-details>
          <template #append-inner v-if="!query">
            <v-icon>search</v-icon>
          </template>
        </v-text-field>

        <v-checkbox hide-details v-model="errorFilter" v-if="nbrAnimalErrors && nbrAnimalErrors > 0" color="black" class="mr-6"
          data-cy="AnimalListErrorsFilterBtn" label="Afficher les erreurs">
        </v-checkbox>

        <v-checkbox hide-details v-model="duplicateFilter" v-if="nbrAnimalDuplicates && nbrAnimalDuplicates > 0" color="black"
          data-cy="AnimalListWarningsFilterBtn" label="Afficher les doublons">
        </v-checkbox>
      </div>

      <v-spacer></v-spacer>

      <v-btn icon size="36" data-cy="AnimalListDeleteBtn" class="mr-2 action"
        :disabled="!animalsSelected || animalsSelected.length < 1 || flight.archived" @click="askDeleteAnimals()">
        <v-icon>delete</v-icon>
      </v-btn>

      <v-btn variant="outlined" rounded class="text-uppercase" data-cy="AddAnimalBtn" :disabled="flight.archived"
        @click="askCreateEditAnimal()">
        <v-icon left>add</v-icon>
        Ajouter un animal
      </v-btn>
    </div>

    <v-data-table :headers="headers" :search="query" :items="animalListFiltered" v-model="animalsSelected"
      class="airvam-table" disable-pagination hide-default-footer density="compact" fixed-header multi-sort show-select
      checkbox-color="primary" :custom-sort="customSort" :sort-by="[{ key: 'animalName' }]"
      loading-text="Chargement des animaux ..." no-results-text="Aucun animal ne correspond à cette recherche"
      no-data-text="La liste des animaux est vide">
      <template #item.animalName="{ item }">
        <div class="row-badges font-weight-bold">
          <v-badge :content="'Erreur'" v-if="item.hasError" inline class="dense" color="error">
          </v-badge>
          <v-badge :content="'Doublon'" v-if="item.isDuplicate" inline class="dense" color="warning">
          </v-badge>
        </div>
        {{ item.animalName }}
      </template>
      <template #item.ownerRank="{ item }">
        {{ item.ownerRank ? item.ownerRank.name : '' }}
      </template>
      <template #item.actions="{ item }">
        <div class="d-flex align-center">
          <v-btn icon size="x-small" flat data-cy="AnimalEditBtn" @click="askCreateEditAnimal(item)" class="mr-1 action"
            :disabled="flight.archived">
            <v-icon>edit</v-icon>
          </v-btn>
          <v-btn icon size="x-small" flat class="action" data-cy="AnimalDeleteBtn" @click="askDeleteAnimal(item)"
            :disabled="flight.archived">
            <v-icon>delete</v-icon>
          </v-btn>
        </div>
      </template>
    </v-data-table>

    <div class="scrollbar-wrapper" ref="wrapperScrollbarDiv">
      <div ref="scrollbarDiv" :style="{ width: scrollBarWidth + 'px' }">
      </div>
    </div>

    <LazyFlightsCaseAnimalDialog v-if="animalDialog && editedAnimal" v-model="animalDialog" :animal="editedAnimal"
      :paxs="flight.paxs" @confirm="createEditAnimal" @close="close" />

    <LazyConfirmDialog v-if="deleteDialog" v-model="deleteDialog" :dialogText="deleteDialogText"
      :dialogTitle="deleteDialogTitle" @confirm="deleteAnimal" @close="close" />
  </v-container>
</template>

<script setup lang="ts">
import type { VDataTable } from 'vuetify/components/VDataTable';
import { max, required } from "@vee-validate/rules";

import { customSort } from "../../../mixins/utilsMixin";
import { Animal } from "~/dto/animal.dto";
import { Flight } from "~/dto/flight.dto";

const props = defineProps<{
  flight: Flight,
  animalList: Animal[]
}>();

const emit = defineEmits(['hasErrors', 'deleteAnimal', 'createEditAnimal']);

const query = ref('');
const editedAnimal: Ref<Animal | null> = ref(null);
const animalsSelected: Ref<Animal[]> = ref([]);
const animalListFiltered: Ref<Animal[]> = ref([]);
const deleteMultipleAnimals = ref(false);
const duplicateFilter = ref(false);
const errorFilter = ref(false);
const animalDialog = ref(false);
const deleteDialog = ref(false);
const deleteDialogTitle = ref('');
const deleteDialogText = ref('');
const nbrAnimalDuplicates = ref(0);
const nbrAnimalErrors = ref(0);
const scrollBarWidth = ref(0);
const wrapperScrollbarDiv: Ref<any> = ref(null);

const askCreateEditAnimal = (animal: Animal) => {
  if (!animal) {
    animal = new Animal();
  }
  editedAnimal.value = Object.assign({}, animal);
  animalDialog.value = true;
}

const askDeleteAnimal = (animal: Animal) => {
  editedAnimal.value = Object.assign({}, animal);
  deleteDialogTitle.value = `Suppression Animal`;
  deleteDialogText.value = `Êtes-vous sûr de vouloir supprimer l'animal "${editedAnimal.value.animalName} ${editedAnimal.value.animalId}" ?`;
  deleteDialog.value = true;
}

const askDeleteAnimals = () => {
  deleteDialogTitle.value = `Suppression Animaux`;
  deleteDialogText.value = `Êtes-vous sûr de vouloir supprimer ${animalsSelected.value.length} Animaux ?`;
  deleteMultipleAnimals.value = true;
  deleteDialog.value = true;
}

const close = () => {
  deleteDialog.value = false;
  animalDialog.value = false;
  editedAnimal.value = null;
  deleteMultipleAnimals.value = false;
}

const createEditAnimal = () => {
  emit('createEditAnimal', editedAnimal.value);
  close();
}

const deleteAnimal = () => {
  if (deleteMultipleAnimals.value) {
    animalsSelected.value.map(a => {
      emit('deleteAnimal', Object.assign({}, a));
      return a;
    });
  } else {
    emit('deleteAnimal', editedAnimal.value);
  }
  close();
}

const countDuplicates = () => {
  const result = Object.values(props.animalList.reduce((r: any | Animal, e: any | Animal) => {
    const k = `${e.animalId}`;
    if (!r[k]) r[k] = { ...e, count: 1 }
    else r[k].count += 1;
    return r;
  }, {}));
  result.forEach((r: any | Animal) => {
    const k = `${r.animalId}`;
    if (r.count > 1) {
      props.animalList.map(a => {
        if (`${a.animalId}` === k) {
          a.isDuplicate = true;
        }
        return a;
      });
    } else {
      const animalFound = props.animalList.find(a => `${a.animalId}` === k);
      if (animalFound) animalFound.isDuplicate = false;
    }
  });
  nbrAnimalDuplicates.value = props.animalList.filter(a => a.isDuplicate).length;
}

const countErrors = () => {
  props.animalList.map(a => {
    const isValid = required(a.animalName) && max(a.animalName, { length: 50 })
      && required(a.animalId) && max(a.animalId, { length: 50 })
      && required(a.animalUnit) && max(a.animalUnit, { length: 50 })
      && required(a.ownerName) && max(a.ownerName, { length: 100 })
      && required(a.ownerUnit) && max(a.ownerUnit, { length: 50 })
      // @ts-ignore
      && required(a.ownerRank) && max(a.ownerRank, { length: 50 })
      && (!a.ownerObservations || max(a.ownerObservations, { length: 255 }))
      && !!a.pax;
    a.hasError = !isValid;
    return a;
  });
  nbrAnimalErrors.value = props.animalList.filter(a => a.hasError).length;
  emit('hasErrors', nbrAnimalErrors.value > 0);
}

const filterAnimals = () => {
  if (nbrAnimalErrors.value < 1) {
    errorFilter.value = false;
  }
  if (nbrAnimalDuplicates.value < 1) {
    duplicateFilter.value = false;
  }
  animalsSelected.value = [];
  animalListFiltered.value = props.animalList.filter(a => {
    let toReturn = true;
    if (duplicateFilter.value) {
      toReturn = a.isDuplicate;
      if (toReturn) {
        return toReturn;
      }
    }
    if (errorFilter.value) {
      toReturn = a.hasError;
    }
    return toReturn;
  });
}

const computeScrollbar = () => {
  const tableObserver = new ResizeObserver(entries => {
    entries.forEach(entry => {
      scrollBarWidth.value = entry.contentRect.width ? entry.contentRect.width : 0;
    });
  });

  const tableElement = document.getElementsByTagName('table')[0];
  tableObserver.observe(tableElement);

  const wrapperScrollbarEl = wrapperScrollbarDiv.value;
  const tableScrollableEl = document.getElementsByClassName('v-data-table__wrapper')[0];
  wrapperScrollbarEl.addEventListener('scroll', () => {
    tableScrollableEl.scrollLeft = wrapperScrollbarEl.scrollLeft;
  });
}

watch(() => props.animalList, () => {
  countDuplicates();
  countErrors();
  filterAnimals();
})

watch(duplicateFilter, () => {
  filterAnimals();
})

watch(errorFilter, () => {
  filterAnimals();
})

onMounted(() => {
  countDuplicates();
  countErrors();
  filterAnimals();
  computeScrollbar();
})

const stickyClass = { class: 'stick-right' };

const headers = [
  { title: 'Nom Animal', value: 'animalName' },
  { title: 'Matricule Animal', value: 'animalId' },
  { title: 'Unité Animal', value: 'animalUnit' },
  { title: 'Nom', value: 'ownerName' },
  { title: 'Unité', value: 'ownerUnit' },
  { title: 'Grade', value: 'ownerRank' },
  { title: 'Observations', value: 'ownerObservations' },
  { title: '', value: 'actions', sortable: false, headerProps: stickyClass, cellProps: stickyClass },
] as VDataTable['$props']['headers'];

</script>

<style lang="scss">
.v-data-table--fixed-header.v-data-table {
  &__wrapper {
    overflow: hidden;
  }

  .row-badges {
    display: flex;
    position: absolute;
    top: 0;

    &>.v-badge:first-child .v-badge__wrapper {
      margin-left: 0;
    }
  }
}

.scrollbar-wrapper {
  height: 10px;
  width: calc(80% - 32px);
  overflow-x: auto;
  overflow-y: hidden;
  position: fixed;
  bottom: 64px;

  &>div {
    height: 10px;
  }
}
</style>
